#!/usr/bin/env python

import os
import os.path
import re
import sys

rec_tagline = re.compile("^traceplay gold \\w+ \\w+ \\d+ \\d+ content_size=(\\d+)$")

app = sys.argv.pop(0)
in_gold_fn = sys.argv.pop(0)
out_gold_dir = sys.argv.pop(0)

try:
    in_f = file(in_gold_fn, "rb")
except:
    print >>sys.stderr, "Can't open input file '%s'" % in_gold_fn
    print >>sys.stderr, ""
    raise

if not os.path.isdir(out_gold_dir):
    print >>sys.stderr, "'%s' is not a directory" % out_gold_dir
    sys.exit(1)

frame_number = 0
while True:
    tagline = in_f.readline()
    tagline.strip()
    if not tagline:
        break

    match = rec_tagline.match(tagline)
    if not match:
        print >>sys.stderr, "tagline does not match format:"
        print >>sys.stderr, "    " + tagline
        sys.exit(1)

    try:
        content_size = int(match.group(1))
    except:
        print >>sys.stderr, "Can't convert content_size '%s' to integer" % match.group(1)
        print >>sys.stderr, ""
        raise

    content = in_f.read(content_size)

    out_f = file(os.path.join(out_gold_dir, "frame_%06d.tpgold" % frame_number), "wb")
    out_f.write(tagline)
    out_f.write(content)
    out_f.close()

    frame_number += 1

in_f.close()

